<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
function split_sql_dump($sql)
    {
    $sql  =preg_replace("/\r/s", "\n", $sql);
    $sql  =preg_replace("/[\n]{2,}/s", "\n", $sql);
    $lines=explode("\n", $sql);

    $queries=array();

    $in_query=0;
    $i       =0;

    foreach ($lines as $line)
        {
        $line = trim($line);

        if (!$in_query)
            {
            if (preg_match("/^CREATE/i", $line))
                {
                $in_query   =1;
                $queries[$i]=$line;
                }
            elseif (!empty($line) && $line[0] != "#")
                {
                $queries[$i]=preg_replace("/;$/i", "", $line);
                $i++;
                }
            }
        elseif ($in_query)
            {
            if (preg_match("/^[\)]/", $line))
                {
                $in_query=0;
                $queries[$i].=preg_replace("/;$/i", "", $line);
                $i++;
                }
            elseif (!empty($line) && $line[0] != "#")
                {
                $queries[$i].=$line;
                }
            }
        }

    return $queries;
    }

function get_table_def_mysql($table, $crlf)
    {
    global $db;
    $dump="DROP TABLE IF EXISTS $table;$crlf";
    $db->query('SET SQL_QUOTE_SHOW_CREATE = 0');
    
    $result=$db->query("SHOW CREATE TABLE $table"); 
    if ($row=$db->fetch_array($result, 0))
        {
        $dump.=str_replace("\n", $crlf, $row[1]);
        }

    $db->free_result();
    echo $dump . ";" . $crlf;
    return true;
    }

function get_table_content_mysql($table, $crlf)
    {
    global $db;
    $result=$db->query("SELECT * FROM $table");

    if ($result && $db->get_numrows($result))
        {
        echo $crlf . "#" . $crlf . "# Table Data for " . $table . $crlf . "#" . $crlf;

        $column_list="";
        $num_fields =$db->get_numfields($result);

        for ($i=0; $i < $num_fields; $i++)
            {
            $column_list.=(($column_list != "") ? ", " : "") . $db->get_fieldname($result, $i);
            }
        }

    while ($row=$db->fetch_array($result))
        {
        $dump = "INSERT INTO " . $table . " (" . $column_list . ") VALUES (";

        for ($i=0; $i < $num_fields; $i++)
            {
            $dump.=($i > 0) ? ", " : "";

            if (!isset($row[$i]))
                {
                $dump.="NULL";
                }
            elseif ($row[$i] == "0" || $row[$i] != "")
                {
                $type=$db->get_fieldtype($result, $i);

                if ($type == "tinyint" || $type == "smallint" || $type == "mediumint" || $type == "int" || $type
                                                                                                               == "bigint"
                    || $type == "timestamp")
                    {
                    $dump.=$row[$i];
                    }
                else
                    {
                    $search_array=array
                        (
                        '\\',
                        '\'',
                        "\x00",
                        "\x0a",
                        "\x0d",
                        "\x1a"
                        );

                    $replace_array=array
                        (
                        '\\\\',
                        '\\\'',
                        '\0',
                        '\n',
                        '\r',
                        '\Z'
                        );

                    $row[$i]=str_replace($search_array, $replace_array, $row[$i]);
                    $dump.="'" . $row[$i] . "'";
                    }
                }
            else
                {
                $dump.="''";
                }
            }

        $dump.=');';
        echo $dump . $crlf;
        }

    echo $crlf;
    return true;
    }
?>